// Rascal, the Advanced Scientific CALculator
// Copyright (C) 2001, Sebastian Ritterbusch (Rascal@Ritterbusch.de)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more detauls.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// Define the following if you do not have proper STL installed...
#define THEREISNOSSTREAM

#ifdef THEREISNOSSTREAM
#include <string>
#include <string.h>
#include <stdio.h>
class ostringstream
{
   private: char  buffer[1024];
   public:
      ostringstream(void) { buffer[0]=0; }
      ostringstream & operator<<(int a)
      {
         sprintf(buffer+strlen(buffer),"%d",a);
         return *this;
      }
      ostringstream & operator<<(double a)
      {
         sprintf(buffer+strlen(buffer),"%lf",a);
         return *this;
      }
      string str(void) const { return string(buffer); }
};
#else
#include <sstream>
#endif

#include <iostream.h>

int showhelp(void)
{
   cout << "Just enter arithmetic expressions to compute the results." << endl;
   cout << "ex.:  >2+3*7"<< endl;
   cout << "       23" << endl << endl;
   cout << "Supported operators are: Arithmetic: + - * / % ^ ! Logic: & | != == < <= > >= ~" << endl;
   cout << "Variables can be defined using the equal sign '=':" << endl;
   cout << "ex.:  >MyVariable=3.123" << endl;
   cout << "       3.123" << endl << endl;
   cout << "Various standard functions are predefined and new functions can be defined:" << endl;
   cout << "ex.:  >MyFunction(x)=2*x+17;" << endl << endl;
   cout << "You may enter matrices and vectors using brackets and use usual operators:" << endl;
   cout << "ex.:  >[1 2;3 4]*[5;6]" << endl; 
   cout << "       [17;39]" << endl << endl;
   cout << "For more information refer preferably to the user manual on your system or to" << endl;
   cout << "http://rascal.sourceforge.net/userdoc/" << endl;
   cout << "For licence information enter 'licence'." << endl;
   return 0;
}

int showlicence(void)
{
   cout << " Rascal, the Advanced Scientific CALculator" << endl;
   cout << " Copyright (C) 2001, Sebastian Ritterbusch (Rascal@Ritterbusch.de)" << endl;
   cout << "" << endl;
   cout << " This program is free software; you can redistribute it and/or" << endl;
   cout << " modify it under the terms of the GNU General Public License" << endl;
   cout << " as published by the Free Software Foundation; either version 2" << endl;
   cout << " of the License, or (at your option) any later version." << endl;
   cout << "" << endl;
   cout << " This program is distributed in the hope that it will be useful," << endl;
   cout << " but WITHOUT ANY WARRANTY; without even the implied warranty of" << endl;
   cout << " MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the" << endl;
   cout << " GNU General Public License for more detauls." << endl;
   cout << "" << endl;
   cout << " You should have received a copy of the GNU General Public License" << endl;
   cout << " along with this program; if not, write to the Free Software" << endl;
   cout << " Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA." << endl;
   cout << endl;
   return 0;
}

int quit_program(void)
{
   exit(0);
   return 0;
}

string output(const valuematrix &a)
{
   int i,j;
   string out("[");
   for(i=0;i<a.N;i++)
   {
      for(j=0;j<a.M;j++)
      {
         value o(output(a(i,j)));
         if(o.isSTRING())
            out+=o.asSTRING();
         else
            out+="Error";
         if(j<a.M-1)
            out+=" ";
      }
      if(i<a.N-1)
         out+=";";
   }
   out+="]";
   return out;
}

string output(const int &a)
{
   ostringstream out;
   out << a;
   return out.str();
}
string output(const double & a)
{
   ostringstream out;
   out << a;
   return out.str();
}
int fac(int a)
{
   int r=1,i;
   for(i=2;i<=a;i++)
      r*=i;
   return r;
}

value stringtoint(string a)
{
   int d;
   sscanf(a.c_str(),"%ld",&d);
   return value(d);
}

value stringtodouble(string a)
{
   double d;
   sscanf(a.c_str(),"%lf",&d);
   return value(d);   
}
