// Rascal, the Advanced Scientific CALculator
// Copyright (C) 2001, Sebastian Ritterbusch (Rascal@Ritterbusch.de)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more detauls.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#include <stdio.h>
#include <fstream.h>
#include <unistd.h>

string gnuplot(const valuematrix & a)
{
   if(!cell(a,1).isSYMREC())
   {
      return "Usage: plot[<function>;<minx>;<maxx>;<stepsize>]";
   }
   symrec *f((symrec*)cell(a,1).asSYMREC());
  
   char buffer[1024];
   char buffer2[1024];
   
   tmpnam(buffer); //  I know that I mustn't use this function :)
   tmpnam(buffer2); // but the man-pages to tell me how I can avoid it!
      
   ofstream out(buffer);

   value xstart(-5),xend(5),xstep(1/32.);
   
   if(a.N>1 || a.M>1)
      xstart=cell(a,2);
   if(a.N>2 || a.M>1)
      xend=cell(a,3);
   if(a.N>3 || a.M>1)
      xstep=cell(a,4);
   
   for(value x=xstart;x<=xend;x=x+xstep)
   {
      out << output(x).asSTRING();
      out << "\t" << output(evaluate(f,x)).asSTRING() << endl;
   }
   out.close();
   
   ofstream out2(buffer2);
   out2 << "plot \"" << buffer << "\" title \"" << f->name << "\" with lines" << endl;
   out2 << "pause -1 \"gnuplot: Hit return to continue\"" << endl;
   
   out2.close();
   
   char buffer3[1024];
   sprintf(buffer3,"gnuplot %s",buffer2);
   
   system(buffer3);
   
   unlink(buffer);
   unlink(buffer2);
   return "ok";
}
